#include <bits/stdc++.h>
using namespace std;

int r, c, k;
int N[4];
string actions[4] = {"top", "bottom", "left", "right"};

int xorsvega() {
	return N[0]^N[1]^N[2]^N[3];
}

void move() {
	int x = xorsvega();
	int najlijevija = sizeof(x)*8-__builtin_clz(x)-1;
	//cout << najlijevija << endl;
	najlijevija = 1<<najlijevija;
	for (int i = 0; i < 4; ++i) {
		if (N[i]&najlijevija) {
			cout << actions[i] << ' ' << (N[i]-(N[i]^x)) << endl;
			cout.flush();
			N[i] ^= x;
			return;
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cin >> r >> c >> k;
	int gore = 2e9, dolje = 0, lijevo = 2e9, desno = 0;
	for (int a, b, i = 0; i < k; ++i) {
		cin >> a >> b;
		gore = min(gore, a);
		dolje = max(dolje, a);
		lijevo = min(lijevo, b);
		desno = max(desno, b);
	}
	N[0] = gore-1;
	N[1] = r-dolje;
	N[2] = lijevo-1;
	N[3] = c-desno;
	int turn = 0;
	//printf("%d %d %d %d\n", N[0], N[1], N[2], N[3]);
	if (xorsvega() == 0) {
		cout << "pass" << endl;
		cout.flush();
		turn = 1;
	}
	while (true) {
		string s; int x;
		if (turn) {
			cin >> s;
			if (s == "yuck!") return 0;
			cin >> x;
			for (int i = 0; i < 4; ++i) {
				if (s == actions[i]) {
					N[i] -= x;
				}
			}
			turn = 0;
		} else {
			move();
			turn = 1;
		}
	}
	
	return 0;
}
